|
请使用QQ关联注册PLM之家,学习更多关于内容,更多精彩原创视频供你学习!
您需要 登录 才可以下载或查看,没有账号?注册
x
8 F& S9 X- U5 i
' Q' c: L: v9 o! Z7 D如何获取选择点映射到视图空间中?源码分享
' h4 ^/ D6 A( }; o9 b+ ?2 M
9 Z4 k* B# ?, C" |# {/ d3 M/ C% F- //------------------------------------------------------------------------------
9 r: B: x( ]# [, J- w - // Select Screen Position and map to Modeling View Plane1 {; d5 b) s8 ]
- //------------------------------------------------------------------------------
0 S- d. q. ^1 u# ]0 i) S - bool GtacPmi::SelectPmiPosition(NXOpen::Point3d &pos)
5 D! t; s3 S5 l: p% X - {
# d2 B, o# M" ]/ n- J% W; f% T" R9 m - NXOpen::View* myView = NULL;# V3 {: S* X& V% O( L! B
- NXOpen::Point3d myCursor(0, 0, 0);. Y! h( {! X) U M$ Y
- 6 B' ^3 y8 y% ~( Y8 [* C
- NXOpen::Selection::DialogResponse myResponse = m_ui->SelectionManager()->SelectScreenPosition("Select Screen Origin", &myView, &myCursor);
/ y( f' t- U+ C* x! v/ t+ N! Z/ M - if (myResponse == NXOpen::Selection::DialogResponsePick)* D# [7 [+ X& H5 x/ }4 Z
- {
7 n1 G% K. M) V& X5 ]6 w& n - // obtain the current default annotation plane where PMIs are placed on) n( |" N* C2 J
- NXOpen::Xform *xform1;( s6 D' ~! e' H
- xform1 = m_wpart->Annotations()->GetDefaultAnnotationPlane(NXOpen::Annotations::PmiDefaultPlaneModelView);
' o+ P# S% A; _! @4 L5 p - NXOpen::Matrix3x3 vmxDefaultPlane = xform1->Orientation();
( B i. s6 d5 H+ o1 ~, [6 l - NXOpen::Point3d ptDefaultPlane = xform1->Origin();
3 N& l- r1 ]: X+ T# O% W+ v - NXOpen::Vector3d vecDefaultPlane(vmxDefaultPlane.Zx, vmxDefaultPlane.Zy, vmxDefaultPlane.Zz);
7 }8 g& P0 J# ~9 E
. r/ i: `8 @( Y4 O8 c, C- // create the ray 'into the screen' at the selected cursor position' k: q0 k. l6 f9 }$ `' Q
- NXOpen::Matrix3x3 vmx = myView->Matrix();) [+ S4 Z( R$ b3 `0 D& Z
- NXOpen::Point3d p1(myCursor.X - vmx.Zx * 1000, myCursor.Y - vmx.Zy * 1000, myCursor.Z - vmx.Zz * 1000);
+ y" [# i# ^+ ]& d$ R( N) N* i7 m - NXOpen::Point3d p2(myCursor.X + vmx.Zx * 1000, myCursor.Y + vmx.Zy * 1000, myCursor.Z + vmx.Zz * 1000);
2 }3 |! e! T/ w1 ~ k- [6 }: | - NXOpen::Line *lineRay = m_wpart->Curves()->CreateLine(p1, p2);
; f2 V1 _, T/ w: d# D" F6 { - lineRay->SetName("Ray");
3 g( ?) h& r. _9 W% N* @
7 U, n: ?# x: o/ ]1 L- }2 u2 l- b- // create the plane from the view to intersect with the ray. {; s7 o1 w& b- ~2 D r
- NXOpen::Plane *planeView = m_wpart->Planes()->CreatePlane(ptDefaultPlane, vecDefaultPlane, NXOpen::SmartObject::UpdateOptionWithinModeling);
6 j1 @0 z0 m, t" s' \6 T4 } - planeView->SetVisibility(NXOpen::SmartObject::VisibilityOptionVisible);8 G# M) O4 T/ U* m
- planeView->SetName("ViewPlane");" `8 y/ ]+ @5 m' R2 N
- 9 e M' a0 ?) g4 J( e. x
- // now create the intersection point
- N1 i, e" d/ h: f. A - NXOpen::Point *pntInterSect = m_wpart->Points()->CreatePoint(planeView, lineRay, NULL, NULL, NXOpen::SmartObject::UpdateOptionWithinModeling); ?" d- w% K- Q( K
- pntInterSect->SetVisibility(NXOpen::SmartObject::VisibilityOptionVisible);
7 v' l I K1 X( T6 ~ - pntInterSect->SeTColor(10); @+ o: I) K' v2 k F/ T
- pntInterSect->SetName("Intersection");' a3 y' }: H& t! H+ k1 y
- ! ~) T5 d5 i( c# D
- pos = pntInterSect->Coordinates();
7 ^4 ?* S7 H" }5 p# m - print("\nPMI Position:", pos);
% z6 @! ~; q# V9 e+ P( s- n
( E( n3 j1 z& t( h, D" P3 n) q- // clean up - comment to see intermediate objects
. b0 z4 Y6 v1 A& J1 B; b6 Q - NXOpen::Session::UndoMarkId markDel = m_session->SetUndoMark(NXOpen::Session::MarkVisibilityVisible, "Delete");# B/ q; s% w5 K4 V
- int nErrs1 = m_session->UpdateManager()->AddToDeleteList(pntInterSect);
+ y- x% V, x' }# f4 q - int nErrs2 = m_session->UpdateManager()->AddToDeleteList(planeView);
, e7 I( {1 q( D9 n& l% G - int nErrs3 = m_session->UpdateManager()->AddToDeleteList(lineRay);6 a1 |$ R: d# R# Y
- int nErrs4 = m_session->UpdateManager()->DoUpdate(markDel);
/ Z) e' f* Q% W' P% C0 K. k - m_session->DeleteUndoMark(markDel, NULL);
% u. H, g: f1 J% N8 R2 s: U% i - - e5 r% r& l4 D, ^5 O
- return true;" b, n/ {( m6 _" w6 m; ?
- }/ |- |5 f) H3 j0 E- d8 [" B
- 2 h0 M" B% n. q, }+ O1 k9 N& Z8 M# Z
- return false;
; B& s r3 L' [1 J1 E8 Y6 j - }
复制代码
/ f1 G0 F1 q8 R$ n* G4 Z
9 ]* s' V8 [# c! a |
|